#!/bin/bash

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

bookname=$1
unzip $1 -d /tmp/epub2html > /dev/null

str0=`find /tmp/epub2html/content/* -regex '.*_1.html'`
let len=${#str0}-6

substr=${str0:23:$len}
substr=${substr%1.html}

files=`ls -l /tmp/epub2html/content/$substr*.html | wc -l`

for x in $(seq 0 $files); do
 
filepart="/tmp/epub2html/content/$substr$x.html"

   if [ -e $filepart ]; then 
     cat $filepart >> ${bookname//.epub/.html}
   fi
done

#copy over the images if you want them
if [ ! -e resources ]; then
  mkdir resources 
fi

`cp /tmp/epub2html/content/resources/*.jpg /tmp/epub2html/content/resources/*.png -t ./resources 2> /dev/null`

rm -R /tmp/epub2html
