# ALSA Z2 Sound Loader - <ray@oddree.com>
# Based on the work of GPSFan (thanks Ken)

# remove old device files if need be
if test -f /dev/audio
then
	rm /dev/audio
fi
if test -f /dev/dsp
then
	rm /dev/dsp
fi
if test -f /dev/mixer
then
	rm /dev/mixer
fi
# create new device files
mknod /dev/audio c 14 4 -m 666
mknod /dev/dsp c 14 3 -m 666
mknod /dev/mixer c 14 0 -m 666
mkdir /dev/snd
mknod /dev/snd/pcmC0D0c c 116 24 -m 666
mknod /dev/snd/timer c 116 33 -m 666
mknod /dev/snd/controlC0 c 116 0 -m 666
mknod /dev/snd/pcmC0D0p c 116 16 -m 666
# load the modules
insmod /mnt/sd0/modules/i2c-core.ko
insmod /mnt/sd0/modules/i2c-algo-bit.ko
insmod /mnt/sd0/modules/i2c-pxa.ko
insmod /mnt/sd0/modules/soundcore.ko
insmod /mnt/sd0/modules/snd.ko
insmod /mnt/sd0/modules/snd-page-alloc.ko
insmod /mnt/sd0/modules/snd-timer.ko
insmod /mnt/sd0/modules/snd-mixer-oss.ko
insmod /mnt/sd0/modules/snd-pcm.ko
insmod /mnt/sd0/modules/snd-pcm-oss.ko
insmod /mnt/sd0/modules/snd-soc-core.ko
insmod /mnt/sd0/modules/snd-soc-pxa2xx.ko
insmod /mnt/sd0/modules/snd-soc-pxa2xx-i2s.ko
insmod /mnt/sd0/modules/snd-soc-wm8750.ko
insmod /mnt/sd0/modules/snd-soc-z2.ko
# attempt to restore settings from asound.state
/mnt/sd0/bin/alsactl -F restore 0

# Unmap cryptic default mappings from OSS mixer controls to ALSA
echo 'PCM "" 0' >/proc/asound/card0/oss_mixer
echo 'ALTPCM "" 0' >/proc/asound/card0/oss_mixer
echo 'IGAIN "" 0' >/proc/asound/card0/oss_mixer
# Make sensible mapping of OSS mixer controls to ALSA for rexima, orpheus
echo 'VOLUME "PCM" 0' >/proc/asound/card0/oss_mixer
echo 'BASS "Bass" 0' >/proc/asound/card0/oss_mixer
echo 'TREBLE "Treble" 0' >/proc/asound/card0/oss_mixer
echo 'SPEAKER "Speaker" 0' >/proc/asound/card0/oss_mixer
#echo 'LINE "Headphone" 0' >/proc/asound/card0/oss_mixer
echo 'MIC "Capture" 0' >/proc/asound/card0/oss_mixer
#echo 'PCM "PCM" 0' >/proc/asound/card0/oss_mixer
echo 'PHONEOUT "Headphone" 0' >/proc/asound/card0/oss_mixer

# Turn it on with amixer (way smaller)
/mnt/ffs/bin/amixer -q sset "Speaker Playback ZC" on
/mnt/ffs/bin/amixer -q sset "Right Mixer" on
/mnt/ffs/bin/amixer -q sset "Left Mixer" on
/mnt/ffs/bin/amixer -q sset "Right Speaker Playback Invert" on
# other IZ2S defaults
/mnt/ffs/bin/amixer -q sset "PCM" 95%
/mnt/ffs/bin/amixer -q sset "Speaker" 0%
/mnt/ffs/bin/amixer -q sset "ALC Capture Target" 0%
/mnt/ffs/bin/amixer -q sset "Bypass Left" 0%
/mnt/ffs/bin/amixer -q sset "Bypass Right" 0%
/mnt/ffs/bin/amixer -q sset "Bypass Mono" 0%
/mnt/ffs/bin/amixer -q sset "Mono" 0%
/mnt/ffs/bin/amixer -q sset "Bass" 47%
/mnt/ffs/bin/amixer -q sset "Treble" 47%
