#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "LeastSquare.h"

#define LINE_LENGTH 80
#define N0  10
#define NUM_DATA_SAMPLES 100;

int main ( int argc, char* argv[])
{
	double* a;
	int n = 1;

	int N_max = 0;
	int N;
	double* x;
	double* y;
	double x_min, x_max;
	double Dx;
	double xp;

	char* data_file ="data";
	char line[LINE_LENGTH];
	FILE* fr;

	switch (argc) 
	{
	case 1:
		break;
	case 2:
		n = atoi (argv[1]);
		break;
	default:
		n = atoi (argv[1]);
		data_file = argv[2];
	}

	if ((fr = fopen (data_file, "r")) == NULL) {
		fprintf (stderr, "Can't open data file.\n");
		exit (1);
	}

	a = (double*)malloc ((n+1)*sizeof(double));

	N = 0;
	x = (double*)malloc (N0*sizeof(double));
	y = (double*)malloc (N0*sizeof(double));			

	while (fgets (line, LINE_LENGTH, fr) != NULL)
	{
		if (line[0] == '#')
			continue;

		sscanf (line, "%lf %lf", x + N, y + N);

		if (N == 0) {
			x_min = x_max = x[0];
		} else {
			if (x[N] < x_min)
				x_min = x[N];
			if (x[N] > x_max)
				x_max = x[N];
		}

		N++;
		if (N >= N_max) {
			N_max += N0;
			x = (double*)realloc (x, N_max*sizeof(double));
			y = (double*)realloc (y, N_max*sizeof(double));			

			if ((x == NULL)||(y == NULL))
				fprintf (stderr, "Can't allocate memory.\n");
		}
	}
		
	LeastSquare (x, y, N, a, n);
	Dx = (x_max - x_min)/NUM_DATA_SAMPLES;

	for (xp = x_min; xp < x_max; xp += Dx)
		printf ("%f %f\n", xp, Poly (a, n, xp));
	
	exit (0); 
}
	
/*
  Local Variables:
  compile-command:"gcc -Wall -g demo_b.c  LeastSquare.c Matrix.c -o demo_b -lm"
  End: 
*/
